module Polynomials
  module Plotable
    def pointset(start,stop,step=0.1)
      data = []
      x = start
      while x < stop
        data << [x,self.(x)]
        x += step
      end
      data << [stop,self.(stop)]
    end

    def grouped_pointset(start,stop,step=0.1,grouped)
      Hash[grouped.map do |key,intervals|
        intervals = intervals.reject { |s,e| e < start || s > stop }
        intervals = intervals.map do |s,e|
          self.pointset([s,start].max, [e,stop].min, step)
        end
        [key,intervals]
      end]
    end
  end
end
